module Algos (G : sig
		type vertex = int
		type graph
		val empty : graph
		val add_vertex : graph -> graph * vertex
		val add_edge : graph -> vertex -> vertex -> graph
		val size : graph -> int
		val has_edge : graph -> vertex -> vertex -> bool
		val successors : graph -> vertex -> vertex list
	      end) =
struct
  let depth_first g =
    let l = ref [] in
    let aux s =
      while not (Stack.is_empty s) do
	let i = Stack.pop s in
	  if not (List.mem i (!l)) then
	    ( l := i::(!l); List.iter (fun j -> Stack.push j s) (G.successors g i) )
      done
    in
      for i = 1 to (G.size g) do
	let s = Stack.create () in
	  Stack.push i s; aux s
      done;
      List.rev (!l)

  let breadth_first g =
    let l = ref [] in
    let aux s =
      while not (Queue.is_empty s) do
	let i = Queue.pop s in
	  if not (List.mem i (!l)) then
	    ( l := i::(!l); List.iter (fun j -> Queue.push j s) (G.successors g i) )
      done
    in
      for i = 1 to (G.size g) do
	let s = Queue.create () in
	  Queue.push i s; aux s
      done;
      List.rev (!l)
      
end
