module G = LGraph
module A = Graph.Algos(G)

let aV g = let (h,x) = G.add_vertex g in h
let aE g i j = G.add_edge g i j

let g = aE
	  (aE
	     (aE
		(aE
		   (aV (aV (aV (aV G.empty))))
		   1 2)
		1 3)
	     2 4)
	  3 4

let print_list l =
  let rec aux = function
    | [] -> print_string "]"
    | x::q -> print_int x; print_string (if q <> [] then "; " else " "); aux q
  in print_string "[ "; aux l

let _ =
  print_string "Size: ";
  print_int (G.size g);
  print_newline ();

  print_string "LGraph: ";
  print_newline ();
  for i = 1 to (G.size g) do
    print_int i;
    print_string " -> ";
    print_list (G.successors g i);
    print_newline ()
  done;

  print_string "AGraph: ";
  print_newline ();
  for i = 1 to (G.size g) do
    for j = 1 to (G.size g) do
      print_string (if G.has_edge g i j then "X" else "-"); print_string " ";
    done;
    print_newline ()
  done;

  print_string "Depth-first: ";
  print_list (A.depth_first g);
  print_newline ();

  print_string "Breadth-first: ";
  print_list (A.breadth_first g);
  print_newline ()
